# This is an example to test Formulapi cv2 Video Capture code
# Choose to run the "original frame size" or "frames divisable by 16" example.


# import the necessary packages
import os
import numpy
import cv2

#ORIGINAL FRAME SIZE
# This will result in strange artifacts being added to frame, e.g. red and blue channels swaping mid frame or darken portions of frame.
frameW = 160 #Divisible by 16
frameH = 120 #Not Divisible by 16

#FRAMES DIVISIBLE BY 16
# This will result in normal frames without artifacts.
#frameW = 160 #Divisible by 16
#frameH = 128 #Divisible by 16

fps = 30

os.system('sudo modprobe bcm2835-v4l2')
cap = cv2.VideoCapture(0) 
cap.set(cv2.cv.CV_CAP_PROP_FRAME_WIDTH, frameW);
cap.set(cv2.cv.CV_CAP_PROP_FRAME_HEIGHT, frameH);
cap.set(cv2.cv.CV_CAP_PROP_FPS, fps);
if not cap.isOpened():
	cap.open()
	if not cap.isOpened():
		print 'Failed to open the camera'
		sys.exit()

cv2.namedWindow("Frame")

while(True):
	ret, frame = cap.read()

	cv2.imshow("Frame",frame)

	ch = cv2.waitKey(1)
	if ch & 0xFF == ord('q'):
		break

cap.release()
cv2.destroyAllWindows()
print "END"

#PLEASE NOTE: 	The cv2 resizing algorithm can resize some non-16-Divisible frames like 160x127 even though 127 is not divisable by 16. 
#				I assume this is because it is rounded up for the resampling. 